<?php

// Id used to identify this page within functions.
$PageID = "ADV_SEARCH";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "layout.inc";
require_once "search.inc";
require_once "language.inc";

//0:id, 1:auth, 2:first searchable
$onload = "document.forms['search'].elements[2].select();";

layout_header(array('onload' => $onload));

layout_page_title();

layout_wizard_start($langText['HEADER'], $langText['DESC']);

?>

<form name='search' action='adv_search.php' method='post'>
	<input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
	<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>
	<table cellpadding="6" cellspacing="0" border="0">

    	<?php

			foreach ($MARC_searchable as $searchable)
			{
				if($MARC_config[$searchable] != 'book_isbn')
				{

				?>

				<tr>
					<td align="right"><?php echo $langText[strtoupper($MARC_config[$searchable])]?>:</td>
					<td align="left"><input type='text' name='<?php echo $searchable?>' size=25 value='<?php if(isset($_REQUEST[$searchable])) print $_REQUEST[$searchable];?>'></td>
				</tr>

				<?php

				}
			}

		?>

		<tr>
	    	<td>&nbsp;</td>
			<td><input type='submit' name='search' value='<?php echo $langText['BUTTON_SEARCH'] ?> >>' class='button'></td>
		</tr>
		<tr>
	    	<td colspan=2>&nbsp;</td>
		</tr>

		<tr>
			<td align="right"><?php echo $langText['SEARCH_FROM'] ?>:</td>
            <td align="left">
                <select name='url'>

				<?php

				foreach ($remote_database as $name => $url)
				{

					print "<option value='".$url."'";
					if(!isset($_REQUEST['url']) && $url == $config['zebra_host'].":".$config['zebra_port']."/".$config['zebra_db'])
					{
						print " selected";
					}
					elseif(isset($_REQUEST['url']) && $url == $_REQUEST['url'])
					{
						print " selected";
					}
					print ">".$langText[strtoupper($name)]."</option>";
				}

				?>

				</select>

			</td>
		</tr>
		<tr>
			<td align="right">
				<?php echo $langText['SEARCH_LOCATION'] ?>:
			</td>
			<td>
				<select name='location'>

				<?php

				$res = mysql_query("SELECT location_id, location_name FROM locations");
				while ($row = mysql_fetch_array($res))
				{

					print "<option value='".$row['location_id']."'";
					if(!isset($_REQUEST['location']) && $row['location_id'] == USER_LOCATION)
					{
						print " selected";
					}
					elseif(isset($_REQUEST['location']) && $row['location_name'] == $_REQUEST['location'])
					{
						print " selected";
					}
					print ">".$row['location_name']."</option>";
				}

				?>

					<option value="all" <?php echo (isset($_REQUEST['location']) && $_REQUEST['location'] == "all") ? "selected" : "";?>><?php echo $langText['LOCATION_ALL']?></option>
				</select>
			</td>
		</tr>
		<tr>
            <td>&nbsp;</td>
			<td>
				<input type="checkbox" name="in_shelf"<?php if(isset($_REQUEST['in_shelf'])) echo " checked"; ?>> <?php echo $langText['STATUS_IN_SHELF']?><br />
				<input type="checkbox" name="not_reserved"<?php if(isset($_REQUEST['not_reserved'])) echo " checked"; ?>> <?php echo $langText['STATUS_NOT_RESERVED']?><br />
			</td>
		</tr>

	</table>
</form>
<br />

<?php


layout_wizard_stop();

if(isset($_REQUEST['search']))
{
	$hits_per_page = 10;
	$position = 1;
	$total_query = "";
	$criteria_count = 0;
	$page_index_url = "";
	$query_parts = array();

    foreach($_REQUEST as $key => $value)
	{
     	if(array_key_exists($key, $MARC_config) && $value != "")
		{
			$criteria_count++;

			$curr_bool = boolify_query($value, $key, $_REQUEST['url']);
			if($curr_bool != 'error bool') {
				if(count($query_parts) < 1) {
					array_push($query_parts, $curr_bool);
				} else {
					$last = end($query_parts);
					$query_parts[count($query_parts)-1] = "@and";
					array_push($query_parts, $last);
					array_push($query_parts, $curr_bool);
				}
				//$total_query .= " ".$curr_bool;
			}
			else {
				$error = 'bool';
				break;
			}
		}

		if(array_key_exists($key, $MARC_config))
		{
			$page_index_url .= "&".$key."=".$value;
		}
	}
	$total_query = join(" ", $query_parts);

	if (isset($_REQUEST['position']))
		$position = $_REQUEST['position'];

	$_REQUEST['element'] = 'F'; //In quick-search it is not possible to change the complexity of the search.

	if(isset($error) && $error == "bool") {
		$error = $langText['ERROR_BOOL'];
		$hits = 0;
	}
	else {
		if($criteria_count > 1)
			list($YAZ_items, $hits) = search("", $total_query, $position, $hits_per_page, $_REQUEST['url']); //Call quick-search from search.inc
		else
			list($YAZ_items, $hits) = search("", $total_query, $position, $hits_per_page, $_REQUEST['url']); //Call quick-search from search.inc
		//list($YAZ_items, $hits, $MARC_raw) = search($criteria, $query, $position, $hits_per_page, $url, "raw");
		$how_many = $hits_per_page;

		// Verify that not more records are fetched than are to be displayed
		// on the current page.
		if(($hits - (($position-1) + $hits_per_page)) < 0) {
			$how_many = $hits-($position-1);
		}

	}

	$rowCount = $hits; //Retrieve the number of records.

	if ($rowCount)
	{
		//$maxNumber = 100;
		//$overflowText = ($rowCount > $maxNumber) ? $langText['TOOMANYBOOKSFOUND'] : "";

		$foundText = ($rowCount == 1) ? $langText['BOOKFOUND'] : $langText['BOOKSFOUND'];
		layout_page_info($rowCount . ' ' . $foundText . ':', 'ok');

//		if ($overflowText)
//			print "<blockquote><font class='error'>" . $overflowText . " " . $maxNumber . "</font></blockquote>";

		$headers = array("&nbsp;", '');

		foreach ($MARC_display_in_list as $value)
		{
			array_push($headers, $langText[strtoupper($MARC_config[$value])]);
		}

		$i = 0;
		$table_header = false;
		$narrowed_count = 0;
		$table_rows = 0;
		$display_narrowed_count = false;
		while($rowCount > $i && $i < $how_many)
		{
			$content = array();
			$row = array();
			$go = true;

			parseMARC($YAZ_items[$i]);
			
			if($_REQUEST['url'] == $config['zebra_host'].":".$config['zebra_port']."/".$config['zebra_db'])
			{
				$display_narrowed_count = true;

				if($_REQUEST['location'] == 'all') {
					$location_sql = '';
				} else {
					$location_sql = " AND book_location='".$_REQUEST['location']."'";
				}

				if (isset($_REQUEST['in_shelf']) && isset($_REQUEST['not_reserved']))
				{
					$sql = 	"SELECT book_id
							FROM books
							WHERE book_control_number=".book_control_number()."
							AND book_borrowed=0 AND book_reserved=0".$location_sql;
				}
				elseif(isset($_REQUEST['in_shelf']))
				{
					$sql = 	"SELECT book_id
							FROM books
							WHERE book_control_number=".book_control_number()."
							AND book_borrowed=0".$location_sql;
				}
				elseif (isset($_REQUEST['not_reserved']))
				{
					$sql = 	"SELECT book_id
							FROM books
							WHERE book_control_number=".book_control_number()."
							AND book_reserved=0".$location_sql;
				}
				else
				{
					$sql = 	"SELECT book_id
							FROM books
							WHERE book_control_number=".book_control_number()."
							".$location_sql;
				}

				$res = mysql_query($sql);
				if(mysql_num_rows($res)) {
					$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
					$narrowed_count++;
				} else {
					$go = false;
				}						
			} else {
				$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
				$display_narrowed_count = false;
			}

			// For debugging purposes!
			/*print "MARC: ";
			print_r($MARC);
			print "<br><br><br>";

			print "ROW: ";
			print_r($row);
			print "<br><br><br>";*/

			if($go)
			{
				if(!$table_header) {
					layout_table_header($headers);
					$table_header = true;
				}	

				if(array_key_exists('book_isbn', $row) && $row['book_isbn'] != "")
					$row['book_isbn'] = format_isbn($row['book_isbn']);

				$info = "<a href='book_info.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&url=".$_REQUEST['url']."&book_control_number=" . book_control_number() . "'>" . layout_insertImg('icon_info.png') . "</a>";

				if($_REQUEST['url'] == $config['zebra_host'].":".$config['zebra_port']."/".$config['zebra_db'])
				{
					if(check_priv('EDIT')) {
						$edit_suggest = layout_blankImg(5) . "<a href='book_edit.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&book_control_number=" . book_control_number() . "'>" . layout_insertImg('icon_edit.png') . "</a>";
						$form = '';
					}
				}
				else
				{
					list($message, $hidden) = book_suggest_message(USER_GIVEN_NAMES." ".USER_SURNAME, book_control_number(), $_REQUEST['url']);
					$edit_suggest = layout_blankImg(5) . "<a href='javascript:document.suggest".book_control_number().".submit();' class='no-underline'>"
									.layout_insertImg('icon_suggest_book.png').
									"</a>";

					$form = "<form name='suggest".book_control_number()."' action='communication.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."' method='post'>
								<input type='hidden' name='message_id' value=''>
								<input type='hidden' name='nature' value='3'>
								<input type='hidden' name='subject' value='".$langText['SUGGEST']."'>
								<input type='hidden' name='message' value='".$message."'>
								<input type='hidden' name='hidden' value='".$hidden."'>
							</form>";
				}

				array_push($content, $info . $edit_suggest, $form);

				while(list($key, $value) = each($row))
				{
					array_push($content, $row[$key]);
				}

				layout_table_row($content);
				$table_rows++;
			}

			$i++;
		}
		
		if($table_header) {
			$page_index = '';
			if($display_narrowed_count) {
				$filtered = guess_filtered_hits($hits, $hits_per_page, $i, $table_rows);
				$page_index = "<span class='page-index'><b>".$filtered."</b> ";
				$page_index .= ($narrowed_count == 1) ? $langText['FILTERED_HIT'] : $langText['FILTERED_HITS'];
			}

			$index_url =	"adv_search.php?id=" . $_REQUEST['id'] .
							"&auth=" . $_REQUEST['auth'] .
							$page_index_url .
							"&url=" . $_REQUEST['url'] .
							"&search=1" .
							"&location=" . $_REQUEST['location'];

			if (isset($_REQUEST['in_shelf'])) $index_url .= "&in_shelf";
			if (isset($_REQUEST['not_reserved'])) $index_url .= "&not_reserved";

			$index = create_page_index($hits, $position, $hits_per_page, $index_url);

			if($index && $display_narrowed_count) {
				$page_index .= " | </span>".$index;
			} elseif($index && !$display_narrowed_count) {
				$page_index = $index;
			} else {
				$page_index .= "</span>";
			}
				
        	layout_table_footer($page_index);
		} elseif($display_narrowed_count) {
			$text = $narrowed_count." ";
			$text .= ($narrowed_count == 1) ? $langText['FILTERED_HIT'] : $langText['FILTERED_HITS'];
			layout_page_info($text);
		}
	}

	else
	{
        if(isset($error))
			layout_page_info($langText['ERROR_BOOL'], 'error');
		else
			layout_page_info($langText['NOBOOKSFOUND'], 'error');
	}

}

layout_footer();

?>
